<?php

/**
 *  2Moons 
 *   by Jan-Otto Kröpke 2009-2016
 *
 * For the full copyright and license information, please view the LICENSE
 *
 * @package 2Moons
 * @author Jan-Otto Kröpke <slaver7@gmail.com>
 * @copyright 2009 Lucky
 * @copyright 2016 Jan-Otto Kröpke <slaver7@gmail.com>
 * @licence MIT
 * @version 1.8.0
 * @link https://github.com/jkroepke/2Moons
 */

class ShowRaportPage extends AbstractGamePage
{
	public static $requireModule = 0;
	
	protected $disableEcoSystem = true;

	function __construct() 
	{
		parent::__construct();
	}
	
	private function BCWrapperPreRev2321($combatReport)
	{
		if(isset($combatReport['moon']['desfail']))
		{
			$combatReport['moon']	= array(
				'moonName'				=> $combatReport['moon']['name'],
				'moonChance'			=> $combatReport['moon']['chance'],
				'moonDestroySuccess'	=> !$combatReport['moon']['desfail'],
				'fleetDestroyChance'	=> $combatReport['moon']['chance2'],
				'fleetDestroySuccess'	=> !$combatReport['moon']['fleetfail']
			);			
		}
		elseif(isset($combatReport['moon'][0]))
		{
			$combatReport['moon']	= array(
				'moonName'				=> $combatReport['moon'][1],
				'moonChance'			=> $combatReport['moon'][0],
				'moonDestroySuccess'	=> !$combatReport['moon'][2],
				'fleetDestroyChance'	=> $combatReport['moon'][3],
				'fleetDestroySuccess'	=> !$combatReport['moon'][4]
			);			
		}
		
		if(isset($combatReport['simu']))
		{
			$combatReport['additionalInfo'] = $combatReport['simu'];
		}
		
		if(isset($combatReport['debris'][0]))
		{
            $combatReport['debris'] = array(
                901	=> $combatReport['debris'][0],
                902	=> $combatReport['debris'][1]
            );
		}
		
		if (!empty($combatReport['steal']['metal']))
		{
			$combatReport['steal'] = array(
				901	=> $combatReport['steal']['metal'],
				902	=> $combatReport['steal']['crystal'],
				903	=> $combatReport['steal']['deuterium']
			);
		}
		
		return $combatReport;
	}
	
	public function battlehall() 
	{
		global $LNG, $USER;
		
		$LNG->includeData(array('FLEET'));
		$this->setWindow('popup');
		
		$RID		= HTTP::_GP('raport', '');

		$db = Database::get();

		$sql = "SELECT 
			raport, time,
			(
				SELECT 
				GROUP_CONCAT(username SEPARATOR ' & ') as attacker
				FROM %%USERS%% 
				WHERE id IN (SELECT uid FROM %%TOPKB_USERS%% WHERE %%TOPKB_USERS%%.rid = %%RW%%.rid AND role = 1)
			) as attacker,
			(
				SELECT 
				GROUP_CONCAT(username SEPARATOR ' & ') as defender
				FROM %%USERS%% 
				WHERE id IN (SELECT uid FROM %%TOPKB_USERS%% WHERE %%TOPKB_USERS%%.rid = %%RW%%.rid AND role = 2)
			) as defender
			FROM %%RW%%
			WHERE rid = :raportID;";

		$Raport = $db->selectSingle($sql, array(
			':raportID'	=> $RID
		));
		
		$Info	= array($Raport["attacker"], $Raport["defender"]);
		
		if(!isset($Raport)) {
			$this->printMessage($LNG['sys_raport_not_found']);
		}
		
		$crom = HTTP::_GP('mode','');
		$CombatRaport			= unserialize($Raport['raport']);
		$CombatRaport['time']	= _date($LNG['php_tdformat'], $CombatRaport['time'], $USER['timezone']);
		$CombatRaport			= $this->BCWrapperPreRev2321($CombatRaport);
		$sql = "SELECT * FROM `uni1_comments` WHERE `hof_id`=:rid;";

		$comments3 = $db->select($sql, array(
			':rid'	=> $RID
		));

        if($db->rowCount() == 0){
            $comments2 = "There are no comments";
        }else{
        	foreach ($comments3 as $comment) {
        		$comments2[] = array(
                    'name'   => $comment['username'],
                    'time'      => gmdate("Y/m/d H:i:s",$comment['time']),
                    'says'   => $comment['comment'],
					'avatar' => 'styles/images/no_avatar.png',
                );
        	}
        }


		
		$this->tplObj->assign_vars(array(
			'com_number'	=> $db->rowCount(),
            'comments'      => $comments2,
            'crom' 			=> $crom,
            'id_ul_hof'     => $RID,
			'Raport'		=> $CombatRaport,
			'Info'			=> $Info,
			'pageTitle'		=> $LNG['lm_topkb']
		));
		
		$this->display('shared.mission.raport.tpl');
	}
	
	public function show() 
	{
		global $LNG, $USER;
		
		$LNG->includeData(array('FLEET'));		
		$this->setWindow('popup');
		$crom = 'lol';
		$y = HTTP::_GP('gets','');

		$db = Database::get();

		if(!empty($y)){
			switch($y){
				case 'add':
					$hof = HTTP::_GP('hof','');

					$raportData = $db->selectSingle("SELECT * FROM %%RW%% WHERE rid=:rid;", array(
						':rid'	=> $hof
					));

					if(empty($raportData)) {
						exit();
					}
					
					$comment = HTTP::_GP('comment','');
					$sql = "INSERT INTO `uni1_comments`
							SET `username`=:username, 
							`comment`=:comment, 
							`time`=".TIMESTAMP.", 
							`hof_id`=:rid
							";

					$db->insert($sql, array(
						':username'	=> $USER['username'],
						':comment'	=> $comment,
						':rid'	=> $hof
					));

	                echo "Comment Inserted";
	                exit();
				break;
				case 'comments':
					$hof = HTTP::_GP('hof','');

					$raportData = $db->selectSingle("SELECT * FROM %%RW%% WHERE rid=:rid;", array(
						':rid'	=> $hof
					));

					if(empty($raportData)) {
						return false;
					}
					$lista = "";
					$sql = "SELECT * FROM `uni1_comments` where `hof_id`=:hof_id order by `time` asc;";

					$cautares = $db->select($sql, array(
						':hof_id'	=> $hof
					));	

					foreach ($cautares as $cautare) {
						$lista .= "<li style=\"background: url('../images/sfondonuovo.jpg') no-repeat scroll -3px 0 grey; margin: 0 5px 0 17px;padding: 15px 0;list-style: none outside none;\">
						    <div style=\"margin:0px 10px 0px 0px;padding: 0px;float:left;\">
						        <img src='styles/resource/images/avatar_default.jpg' height=\"35px\" width=\"35px\">
						    </div>
						    <div style=\"float: left;font-size: 85%;line-height: 1.7;overflow: hidden;text-overflow: ellipsis;text-align: left;\">
						        <p>".$s['username']." at ".gmdate("Y/m/d H:i:s",$s['time'])."</p>
						           ".$s['comment']."
						        </div>
						    <div style=\"clear: both;display: block;font-size: 1px;height: 1px;line-height: 1px;margin-bottom: -1px;\"></div>
						</li>";
					}			

			        /*while($s = $db->fetch_array($cautare)){
			            $lista .= "<li style=\"background: url('../images/sfondonuovo.jpg') no-repeat scroll -3px 0 grey; margin: 0 5px 0 17px;padding: 15px 0;list-style: none outside none;\">
						    <div style=\"margin:0px 10px 0px 0px;padding: 0px;float:left;\">
						        <img src='styles/resource/images/avatar_default.jpg' height=\"35px\" width=\"35px\">
						    </div>
						    <div style=\"float: left;font-size: 85%;line-height: 1.7;overflow: hidden;text-overflow: ellipsis;text-align: left;\">
						        <p>".$s['username']." at ".gmdate("Y/m/d H:i:s",$s['time'])."</p>
						           ".$s['comment']."
						        </div>
						    <div style=\"clear: both;display: block;font-size: 1px;height: 1px;line-height: 1px;margin-bottom: -1px;\"></div>
						</li>";
	                }*/
	                echo $lista;
	                exit();
				break;
			}
		}
		
		$RID		= HTTP::_GP('raport', '');

		$sql = "SELECT raport,attacker,defender FROM %%RW%% WHERE rid = :reportID;";
		$raportData = $db->selectSingle($sql, array(
			':reportID'	=> $RID
		));
		
		if(empty($raportData)) {
			$this->printMessage($LNG['sys_raport_not_found']);
		}
		
		// empty is BC for pre r2484
		$isAttacker = empty($raportData['attacker']) || in_array($USER['id'], explode(",", $raportData['attacker']));
		$isDefender = empty($raportData['defender']) || in_array($USER['id'], explode(",", $raportData['defender']));
		
		if(empty($raportData) || (!$isAttacker && !$isDefender)) {
			$this->printMessage($LNG['sys_raport_not_found']);
		}

		$CombatRaport			= unserialize($raportData['raport']);
		if($isAttacker && !$isDefender && $CombatRaport['result'] == 'r' && count($CombatRaport['rounds']) <= 2) {
			$this->printMessage($LNG['sys_raport_lost_contact']);
		}
		
		$CombatRaport['time']	= _date($LNG['php_tdformat'], $CombatRaport['time'], (isset($USER['timezone']) ? $USER['timezone'] : Config::get('timezone')));
		
		$CombatRaport			= $this->BCWrapperPreRev2321($CombatRaport);
		
		$this->tplObj->assign_vars(array(
			'Raport'	=> $CombatRaport,
			'pageTitle'	=> $LNG['sys_mess_attack_report'],
                        'crom'                  => $crom,
		));
		
		$this->display('shared.mission.raport.tpl');
	}
}